********************************************************************
* Program....: VSSHist.PRG
* Version....: 1.0
* Author.....: Ted Roche
* Date.......: November 18, 2000
* Notice.....: Copyright  2000 Ted Roche, All Rights Reserved.
* Compiler...: Visual FoxPro 07.00.0000.8902 for Windows
* Abstract...: Demonstrate SourceSafe Automation capabilities
* Changes....:
********************************************************************

#DEFINE CRLF CHR(13)+CHR(10)  && carriage return & line feed

ACTIVATE SCREEN
CLEAR

* Again, read the Registry using the Fox Foundation Classes 

LOCAL oRegistry, cVSSPath
cVSSPATH = SPACE(128)
#DEFINE HKEY_LOCAL_MACHINE          -2147483646
oRegistry = NEWOBJECT("Registry", HOME()+"FFC\Registry.VCX")
lnError = oRegistry.GetRegKey("Current Database", @cVSSPath, ;
          "Software\Microsoft\SourceSafe", HKEY_LOCAL_MACHINE)
          
LOCAL loVSS AS SourceSafe.VSSDatabase
loVSS = CreateObject("SourceSafe")
* Note the Admin has no password, for demo purposes
* Don't do this with your production data!
loVSS.Open(cVSSPath + "\SrcSafe.INI", "admin", "")

* Add two Users
LOCAL loUser as SourceSafe.VSSUser
loUser=loVSS.AddUser("Sam","PASSWORD",.F.)
loUser=loVSS.AddUser("Ella","PASSWORD",.F.)

* Close and open VSS
loVSS = .NULL.
loVSS = CreateObject("SourceSafe")

* Ella creates a new top-level project
LOCAL loProj as SourceSafe.IVSSItem
loVSS.Open(cVSSPath + "\SrcSafe.INI", "Ella", "PASSWORD")
loProj = loVss.VSSItem("$/").NewSubproject("SamAndElla", "New Demo Project")

* Ella adds a file to the project
STRTOFILE("our forefathers brought forth upon this continent", ;
  "C:\Gettysburg.txt")
loProj.Add("C:\Gettysburg.txt", "Ella's initial load of the file")

* Close and open VSS
loVSS = .NULL.
loVSS = CreateObject("SourceSafe")

* Sam checks out the file, modifies it
loVSS.Open(cVSSPath + "\SrcSafe.INI", "Sam", "PASSWORD")
loProj = loVss.VSSItem("$/SamAndElla/Gettysburg.txt").Checkout("Sam's" + ;
          " initial checkout", "C:\Gettysburg.txt")
LOCAL lcString
lcString = FILETOSTR("C:\Gettysburg.txt")
lcString = "Four score and seven years ago, " + CRLF + lcString 
STRTOFILE(lcString, "C:\Gettysburg.txt")
* Sam checks the file in
loProj = loVss.VSSItem("$/SamAndElla/Gettysburg.txt").CheckIn("Sam " + ;
           "made his changes")

* Sam adds a label to the project
loProj = loVSS.VSSItem("$/SamAndElla").Label("Sam's first draft", ;
           "Sam added a label")

* Close and open VSS
loVSS = .NULL.
loVSS = CreateObject("SourceSafe")

* Ella checks out the file and modifies it
loVSS.Open(cVSSPath + "\SrcSafe.INI", "Ella", "PASSWORD")
loProj = loVss.VSSItem("$/SamAndElla/Gettysburg.txt").Checkout("Ella " + ;
           "makes changes", "C:\Gettysburg.txt")
lcString = FILETOSTR("C:\Gettysburg.txt")
lcString = lcString +CRLF+ "a new nation, conceived in liberty and dedicated"+;
                        "to the proposition that all men were created equal."
STRTOFILE(lcString, "C:\Gettysburg.txt")

* We list the current checkouts on the file
? "Ella's second checkout:"
? "Checked out: ", loVss.VSSItem("$/SamAndElla/Gettysburg.txt").Checkouts.Count
WITH loVss.VSSItem("$/SamAndElla/Gettysburg.txt").Checkouts.Item(1)
 ? .Comment
 ? .Date
 ? .LocalSpec
 ? .VersionNumber
ENDWITH

WAIT 

* Ella checks the file in
loProj = loVss.VSSItem("$/SamAndElla/Gettysburg.txt").CheckIn("Ella " + ;
       "made her changes")

* Close and open VSS
loVSS = .NULL.
loVSS = CreateObject("SourceSafe")
* Log in as the administrator to see what these people
* have been up to
loVSS.Open(cVSSPath + "\SrcSafe.INI", "admin", "")

* We list the history of versions
? "The complete history: "
LOCAL loVersion as SourceSafe.IVSSVersion
FOR EACH loVersion IN loVss.VSSItem("$/SamAndElla/Gettysburg.txt").Versions
  ? "Action: " + ALLTRIM(loVersion.Action)
  ? " Comment: " + ALLTRIM(loVersion.Comment)
  ? " Label: " + ALLTRIM(loVersion.Label)
  ? " Label Comment: " + ALLTRIM(loVersion.LabelComment)
  ? " User: " + ALLTRIM(loVersion.Username)
  ? " VersionNumber: " + TRANSFORM(loVersion.VersionNumber)
ENDFOR

RETURN

PROCEDURE Cleanup

LOCAL oRegistry, cVSSPath
cVSSPATH = SPACE(128)
#DEFINE HKEY_LOCAL_MACHINE          -2147483646
oRegistry = NEWOBJECT("Registry", HOME()+"FFC\Registry.VCX")
lnError = oRegistry.GetRegKey("Current Database", @cVSSPath, ;
          "Software\Microsoft\SourceSafe", HKEY_LOCAL_MACHINE)

LOCAL loVSS AS SourceSafe.VSSDatabase
loVSS = CreateObject("SourceSafe")
loVSS.Open(cVSSPath + "\SrcSafe.INI", "admin", "")
loVss.Users("Sam").Delete
loVss.Users("Ella").Delete
loVSS.VSSItem("$/SamAndElla").Destroy()
RETURN
