********************************************************************
* Program....: VSSUser.PRG
* Version....: 1.0
* Author.....: Ted Roche
* Date.......: November 18, 2000
* Notice.....: Copyright  2000 Ted Roche, All Rights Reserved.
* Compiler...: Visual FoxPro 07.00.0000.8902 for Windows
* Abstract...: Demonstrate the ability to add, iterate and delete
* ...........: users from the SourceSafe database
* Changes....:
********************************************************************

* Again, read the Registry using the Fox Foundation Classes 

LOCAL oRegistry, cVSSPath
cVSSPATH = SPACE(128)
#DEFINE HKEY_LOCAL_MACHINE          -2147483646
oRegistry = NEWOBJECT("Registry", HOME()+"FFC\Registry.VCX")
lnError = oRegistry.GetRegKey("Current Database", @cVSSPath, ;
          "Software\Microsoft\SourceSafe", HKEY_LOCAL_MACHINE)
          
LOCAL loVSS AS SourceSafe.VSSDatabase
loVSS = CreateObject("SourceSafe")
* Note the Admin has no password, for demo purposes
* Don't do this with your production data!
loVSS.Open(cVSSPath + "\SrcSafe.INI", "admin", "")

* Add a new User
LOCAL loUser as SourceSafe.VSSUser
loUser=loVSS.AddUser("NewUser","PASSWORD",.F.)
? loUser.Name      && "New User"
* ? loUser.Password  && throws an error "Member not found"
? loUser.ProjectRights && 15
? loUser.ReadOnly      && .F.

* Display the list of all the users
LOCAL loUsers as SourceSafe.IVSSUsers
loUsers = loVss.Users
? loUsers.Count, " total users"
FOR each loUser in loUsers
  ? loUser.Name
endfor

* Delete an existing user
loUsers.Item("NewUser").Delete
